#include <stdio.h>
#include <float.h>

union u {
	unsigned long l[2];
	double d;
};

union u a = { d: 0.5 };
union u b = { d: 2.0 };
union u c;

void printr(char *msg)
{
	printf(msg);
	printf("%20lf [%08lX:%08lX]\n", c.d, c.l[0], c.l[1]);
}

int main ()
{
	printf ("a = %lf [%08lX:%08lX], b = %lf [%08lX:%08lX]\n", a.d, a.l[0], a.l[1], b.d, b.l[0], b.l[1]);
	c.d = pow(a.d, -1.0);
	printr ("pow(a, -1.0) = ");
	c.d = a.d + b.d;
	printr ("a + b        = ");
	c.d = 2.0 * b.d;
	printr ("2.0 * b      = ");
	c.d = a.d + 2.0 * b.d;
	printr ("a + 2.0 * b  = ");
	c.d = a.d + 4.0 * b.d;
	printr ("a + 4.0 * b  = ");
	fflush (stdout);
	c.d = c.d / 0.0 + 1;
	printr ("c / 0.0 + 1  = ");
}
